"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""

import abc
import collections.abc
import google.protobuf.empty_pb2
import grpc
import grpc.aio
import ryax.worker.infrastructure.grpc.vpa_protocol.vpa_protocol_pb2
import typing

_T = typing.TypeVar("_T")

class _MaybeAsyncIterator(collections.abc.AsyncIterator[_T], collections.abc.Iterator[_T], metaclass=abc.ABCMeta): ...

class _ServicerContext(grpc.ServicerContext, grpc.aio.ServicerContext):  # type: ignore[misc, type-arg]
    ...

class VpaStub:
    def __init__(self, channel: typing.Union[grpc.Channel, grpc.aio.Channel]) -> None: ...
    NewRecommendations: grpc.UnaryUnaryMultiCallable[
        ryax.worker.infrastructure.grpc.vpa_protocol.vpa_protocol_pb2.NewRecommendationsRequest,
        google.protobuf.empty_pb2.Empty,
    ]

class VpaAsyncStub:
    NewRecommendations: grpc.aio.UnaryUnaryMultiCallable[
        ryax.worker.infrastructure.grpc.vpa_protocol.vpa_protocol_pb2.NewRecommendationsRequest,
        google.protobuf.empty_pb2.Empty,
    ]

class VpaServicer(metaclass=abc.ABCMeta):
    @abc.abstractmethod
    def NewRecommendations(
        self,
        request: ryax.worker.infrastructure.grpc.vpa_protocol.vpa_protocol_pb2.NewRecommendationsRequest,
        context: _ServicerContext,
    ) -> typing.Union[google.protobuf.empty_pb2.Empty, collections.abc.Awaitable[google.protobuf.empty_pb2.Empty]]: ...

def add_VpaServicer_to_server(servicer: VpaServicer, server: typing.Union[grpc.Server, grpc.aio.Server]) -> None: ...
